#include "xmlio.hpp"

using namespace XMLIOSERVER;
using namespace XMLIOSERVER::XML;

using namespace std;

extern "C" void main_c_(void) ;

void main_c_ (void)
{
   try
   {
      /*string file("/local/XMLIOSERVER_DEV/dev_rv/test/iodef_test.xml");
      //string file("/local/XMLIOSERVER_DEV/dev_rv/iodef_test.xml");

      ifstream istr( file.c_str() , ifstream::in );

      // On commence la lecture du flux de donnée xml qui doit posséder pour racine un unique noeud nommé "simulation".
      XMLNode node = XMLNode::CreateNode(istr, Context::GetRootName());
      // On parse le fichier xml noeud par noeud (ie on construit dynamiquement notre arbre d'objets).
      XMLParser::Parse(node);

      // On résoud les héritages descendants ainsi que les héritages par référence.
      Context::ResolveInheritance();*/

      AbstractCalendar* calendar = new GregorianCalendar();
      Date dd (*calendar, 2000, 05, 03, 00, 00, 00) ;
      Date ddd(*calendar, 2030, 11, 02, 10, 33, 40) ;

      Date d1 (*calendar, 2007, 11, 12, 00, 00, 00) ;
      Date d2 (*calendar, 2008, 11, 12, 00, 00, 00) ;

      string sttr("12/07/2005 - 10:11:30");
      string stttr("111s 14.36 mi 7y 3.9y 3.4 mg");
      Date d3 = Date::FromString(sttr, *calendar);

      // Les mois sont considérés comme des entiers mais stockés comme des flottants.
      Duration sc0 = Second * -65.3 + Minute * 117.5   + Hour * 65.9  + Day * 417.8 + Month * 16.0  - Year * 17.5;
      Duration sc1 = Second * 175.3 - Minute * 13109.6 + Hour * 135.1 - Day * 616.4 + Month * 236.0 + Year * 33.9;
      Duration sc2 = 60 * Day;

      Duration sc3 = Duration::FromString(stttr);

      std::cout << calendar->getInitDate()    << std::endl;
      std::cout << calendar->getCurrentDate() << std::endl;

      std::cout << boolalpha << (calendar->getInitDate() != calendar->getCurrentDate()) << std::endl;

      std::cout << (Time)d2 - (Time)(d1 + 365 * Day) << std::endl;
      std::cout << sc0 << std::endl << sc1 << std::endl << sc1 - sc0 << std::endl;
      std::cout << ddd - dd << std::endl;
      std::cout << dd << std::endl;
      std::cout << (Time)dd << std::endl;
      std::cout << calendar->getNbSecond(dd) << std::endl;

      std::cout << (dd+sc2) << std::endl;
      std::cout << (d3)  << std::endl;

      std::cout << (sc3) << std::endl;

      delete calendar;

      //On écrit l'arborescence résultante du traitement sur la sortie.
      //Context::ShowTree(std::clog);

   }
   catch(const Exception &exc)
   {  // Pour tout type d'exceptions, on note les informations sur la sortie paramétrée.
      ERROR(exc.displayText());
      // On retourne le code d'erreur en fin d'application pour traitements éventuels.
      // return (exc.code());
   }

// return (0);
}
